
directive open_env "zinc";;

(* BEGINNING OF LEXICALS *)

let syntax_name = "zinc";;

let zinc_IDENT = 257;;
let zinc_STRING = 258;;
let zinc_INFIX = 259;;
let zinc_BOOL = -1;;
let zinc_NUM = -1;;
let zinc_INT = 262;;
let zinc_FLOAT = 263;;
let zinc_CHAR = 264;;
let zinc_EOF = 0;;
let current_syntax = "zinc";;
let zinc_syntax_flag = false;;
let zinc_syntax_type = false;;
let zinc_sub_syntaxes =
[("Implementation",#{335},(MLconsttyp ("impl_phrase",[])));
 ("Interface",#{336},(MLconsttyp ("intf_phrase",[])));
 ("Expr",#{337},(MLconsttyp ("expression",[])));
 ("Struct_constant",#{338},(MLconsttyp ("struct_constant",[])));
 ("Atomic_constant",#{339},(MLconsttyp ("atomic_constant",[])));
 ("Pattern",#{340},(MLconsttyp ("pattern",[])));
 ("Ide",#{341},(MLconsttyp ("string",[])));
 ("Qual_ident",#{342},(MLconsttyp ("qualified_ident",[])));
 ("Ext_ident",#{343},(MLconsttyp ("global_reference",[])));
 ("Type",#{344},(MLconsttyp ("type_expression",[])));
 ("Simple_type",#{345},(MLconsttyp ("type_expression",[])));
 ("Type_expr",#{346},(MLconsttyp ("typ",[])));
 ("Value_decl",#{347},
  (MLconsttyp
   ("list",
    [(MLconsttyp
      ("*",
       [(MLconsttyp ("string",[]));
        (MLconsttyp
         ("*",
          [(MLconsttyp ("type_expression",[]));
           (MLconsttyp ("prim_desc",[]))]))]))])));
 ("Type_decl",#{348},
  (MLconsttyp
   ("list",
    [(MLconsttyp
      ("*",
       [(MLconsttyp ("string",[]));
        (MLconsttyp
         ("*",
          [(MLconsttyp ("list",[(MLconsttyp ("string",[]))]));
           (MLconsttyp ("type_decl",[]))]))]))])));
 ("Exc_decl",#{349},
  (MLconsttyp
   ("list",
    [(MLconsttyp
      ("*",
       [(MLconsttyp ("string",[]));
        (MLconsttyp
         ("list",
          [(MLconsttyp
            ("*",
             [(MLconsttyp ("type_expression",[]));
              (MLconsttyp ("mutable_flag",[]))]))]))]))])))]
;;
let zinc_strings =
[("in",#{266}); ("!",#{267}); ("where",#{268}); ("function",#{269});
 ("let",#{270}); ("->",#{271}); ("fun",#{272}); ("for",#{273});
 ("value",#{274}); ("as",#{275}); ("/",#{276}); ("@",#{277});
 ("prefix",#{278}); ("[|",#{279}); (".",#{280}); ("::",#{281});
 ("<>",#{282}); ("not",#{283}); ("<-",#{284}); ("begin",#{285});
 ("-",#{286}); ("!=",#{287}); (">",#{288}); ("_",#{289});
 ("match",#{290}); ("=",#{291}); (",",#{292}); ("of",#{293});
 (".(",#{294}); ("+",#{295}); ("^",#{296}); ("<",#{297});
 ("end",#{298}); ("]",#{299}); ("try",#{300}); ("while",#{301});
 ("*",#{302}); (";",#{303}); (":",#{304}); (")",#{305}); ("}",#{306});
 ("[",#{307}); ("(",#{308}); (">=",#{309}); ("'",#{310});
 ("__",#{311}); ("else",#{312}); ("rec",#{313}); ("==",#{314});
 ("|",#{315}); ("and",#{316}); ("{",#{317}); (";;",#{318});
 ("<=",#{319}); ("&",#{320}); ("mutable",#{321}); ("if",#{322});
 ("type",#{323}); ("or",#{324}); ("done",#{325}); ("do",#{326});
 (":=",#{327}); ("|]",#{328}); ("down",#{329}); ("to",#{330});
 ("then",#{331}); ("#",#{332}); ("exception",#{333}); ("with",#{334})]
;;
let zinc_strdelim = 
"\""
;;
let zinc_cmndelim = 
"%"
;;
let zinc_double = 
[(#{124},[(#{93},"|]")]); (#{59},[(#{59},";;")]);
 (#{61},[(#{61},"==")]); (#{95},[(#{95},"__")]);
 (#{62},[(#{61},">=")]); (#{46},[(#{40},".(")]);
 (#{33},[(#{61},"!=")]);
 (#{60},[(#{61},"<="); (#{45},"<-"); (#{62},"<>")]);
 (#{58},[(#{61},":="); (#{58},"::")]); (#{91},[(#{124},"[|")]);
 (#{45},[(#{62},"->")])]
;;

(* BEGINNING OF TABLES *)
default_ol_grammar:=("zinc","");;
let  yyexca = [|
-1; 1;
	0; -1;
	-2; 0;
-1; 67;
	257; 198;
	258; 198;
	262; 198;
	263; 198;
	264; 198;
	278; 198;
	286; 198;
	289; 198;
	307; 198;
	308; 198;
	317; 198;
	-2; 165;
-1; 68;
	257; 197;
	258; 197;
	262; 197;
	263; 197;
	264; 197;
	278; 197;
	286; 197;
	289; 197;
	307; 197;
	308; 197;
	317; 197;
	-2; 166
	|];;
let YYNPROD = 236;;
let YYLAST = 2340;;
let  yyact = [|

  27; 329; 400; 398;  78; 417; 141; 349;  96;  67;
  72;  62;  77;  77;  77;  77;  89; 392;  56;  86;
 125; 327; 406; 280;  80;  77; 295; 307; 146; 323;
 330; 139; 230; 144;  67;  79; 291; 290; 399; 289;
 288;  94;  77;  77; 143;  94; 335; 262; 282;  84;
  97; 261; 190;  89; 255; 260; 228; 222; 191; 125;
 190; 217; 257; 319; 144; 161; 191; 153;  18; 355;
  67;  67;  77;  57;  93; 196;  83; 192;  94; 124;
  77; 300; 301;  77;  83;  77; 320; 212;  61; 300;
 301; 385; 193; 134; 135; 190; 137; 138; 334; 140;
 193; 191; 148; 190; 424; 150; 254; 276; 156; 191;
 366; 190; 192; 147; 304; 368; 190; 191; 224; 356;
 192; 125; 191; 125; 190; 427; 144; 209; 192; 209;
 191; 303;  77; 192;  77; 193; 284; 143;  43; 285;
 258; 192; 204; 193; 144; 310; 218; 202; 312; 200;
 203; 193; 371; 281; 418; 143; 193; 280; 208;  44;
 208; 311; 287; 388; 193; 305; 302; 231; 232; 233;
 234; 235; 236; 237; 238; 239; 240; 241; 242; 243;
 244; 245; 246; 247; 248; 249; 250; 251; 100;  82;
 125;  83;  67;  67;  67; 209;  67; 120; 268; 209;
 265; 209; 229; 393; 269; 102;  43;  49; 209;  77;
  77;  47;  48;  50; 309; 364;  42;  43;  89;  77;
 393; 158; 298; 315; 100; 191; 208;  44;  39; 267;
 208; 101; 208; 120;  40; 386; 192; 326;  44; 208;
 324; 102; 106; 268; 308; 338; 105;  94; 191;  43;
 306; 104; 286; 272; 125; 377;  38;  37; 125; 355;
 103; 107; 361; 339; 136; 191;  41; 101;  77;  43;
  44; 294; 296; 297;  67; 299;  73; 274;  67;  77;
 419; 206; 120; 351; 395;  77; 335; 255; 423;  49;
  44; 412;  52;  47;  48;  50; 263;  44; 197; 198;
  97;  77; 346; 293;  67; 357;  77;  67; 223;  77;
 213;  77; 129;  77;  75;  88; 227; 363;  91; 128;
  24;  77;  90; 333; 221; 367; 337; 151; 365; 130;
  77; 216; 142; 328;  87; 318; 342;  92; 343; 344;
 345;  53; 347; 126; 348; 133;  36; 394; 352; 370;
  55;  54; 369; 147; 354;  63;  67; 350;  76;  81;
  81;  81;  77; 160; 373; 372;  63; 154; 401; 211;
  35; 162; 194;  77; 205; 187; 185;  59; 123; 157;
  63; 322; 387; 203; 144;  67; 360; 184; 159; 389;
 407;  46; 321; 402;  77; 143; 220; 308; 411; 231;
  68; 413;  74; 374; 219;  63; 375; 376; 414; 410;
 215;  68; 214; 408; 226; 225;  63;  63; 207; 397;
 401; 426; 425;  67; 145;  68; 210; 396;  77;  81;
 430; 210; 431; 391; 390; 296;  43;  49;  95; 416;
 415;  47;  48;  50;  85; 403;  51; 404; 359; 405;
  68; 358;   3; 409; 133; 145; 121;  44; 259;   2;
 127;  68;  68; 266; 147;  65;   1;  63;  66;  63;
   0;   0;   0;   0; 421;   0; 275;   0; 264;   0;
   0;   0;   0;   0; 199;   0;  70;  69; 428;   0;
  45; 100;   0; 186;   0;   0;  71; 433;  60;  64;
 120;   0; 350;   0;   0;   0; 353;   0; 102;   0;
  64;   0;  68; 105;  68; 188;   0; 145; 104;   0;
  23;   0;   0;  64;  64;   0;   0; 103;   0;   0;
   0;   0;   0; 314; 101; 145;  63;   0;  63;  63;
  63; 317;  63; 325;   0; 316;   0; 313;   0;  64;
   0;   0;  43;  49;  64;  81;  81;  47;  48;  50;
  64;  64;  42;   0;   0;  81;   0;   0;   0;   0;
   0;   0;   0;  44;  39; 131;   0; 252;   0; 256;
  40;  68;   0;  68;  68;  68;   0;  68;   0; 132;
   0;   0;   0;   0;   0;   0;   0;   0;   0;   0;
  63;   0;  38;  37;  63;   0;   0;   0;   0;   0;
   0;  64;  41;  64; 341;   0;  64;   0;   0;   0;
  63;   0;   0;   0;  63;  81;   0;   0;   0;   0;
   0; 159;   0;   0;  64;   0;   0;   0;   0;   0;
   0;   0;   0;   0;   0;  68; 292;  81;   0;  68;
  63;   0; 207;  63;   0; 210;   0; 362;   0;  81;
   0;   0;   0;   0;   0;  68;   0;  81;   0;  68;
   0;   0;   0;   0;   0;   0;  81;   0;   0;   0;
  64;   0;  64;  64;  64;   0;  64;   0;   0;   0;
   0;   0;   0;   0;   0;  68;   0;   0;  68;   0;
 100;   0;  63;   0;   0;   0;   0;   0;  81; 120;
 332;   0;   0;   0; 336;   0;   0; 102; 106; 210;
   0;   0; 105; 114;   0;   0;   0; 104; 115; 109;
   0;  63; 110; 331;   0;   0; 103; 107; 108;   0;
  81;   0;   0; 101;  64;   0;   0;  68;  64;   0;
 112;   0;   0;   0;   0; 111;   0;   0;   0;   0;
 113; 117;   0;   0;  64; 118;   0;   0;  64;  63;
   0;   0;   0;   0;  81; 145;  68;  43;  49;   0;
   0;   0;  47;  48;  50;   0;   0;  42;   0;  33;
  19;   0;  32;  30;  64;   0;   0;  64;  44;  39;
   0;   0;   0;  26;   0;  40;  25;   0;   0;   0;
  31;   0;   0;   0;  68;   0;   0;   0;   0;   0;
  34;  29;   0;   0;   0;   0;   0;  38;  37;   0;
   0;   0;   0;   0;   0;   0;   0;  41;   0;   0;
   0;   0;  28;  20;   0;   0;  64;   0;   0;   0;
   0;   0;  22;  21;   0;   0;   4;   5;   6;   7;
   8;   9;  10;  11;  12;  13;  14;  15;  16;  17;
   0; 100;   0;   0;  64;  64;   0;   0;   0;   0;
 120;   0;   0;   0;   0;   0;   0;   0; 102; 106;
  43;  49;   0; 105; 114;  47;  48;  50; 104; 115;
 109;   0;   0; 110;  99;   0;   0; 103; 107; 108;
   0;  44;   0;  64; 101; 119;   0;   0;   0;  65;
 100; 112;  66;   0;   0;   0; 111;   0;   0; 120;
   0; 113; 117;   0;   0;   0; 118; 102; 106; 116;
  70;  69; 105; 114;   0;   0; 277; 104; 115; 109;
  71;   0; 110;  99;   0;   0; 103; 107; 108;   0;
   0;   0;   0; 101; 119;   0;   0;   0;   0; 100;
 112;   0;   0;   0;   0; 111;   0;   0; 120;   0;
 113; 117;   0;   0;   0; 118; 102; 106; 116;   0;
   0; 105; 114;   0;   0; 273; 104; 115; 109;   0;
   0; 110;  99;   0;   0; 103; 107; 108;   0;   0;
   0;   0; 101; 119;   0;   0;   0;   0;   0; 112;
   0;   0;   0;   0; 111;   0; 100;   0;   0; 113;
 117;   0;   0;   0; 118; 120;   0; 116;   0; 382;
 381;   0;   0; 102; 106;   0;   0;   0; 105; 114;
   0;   0;   0; 104; 115; 109;   0;   0; 110;  99;
   0;   0; 103; 107; 108;   0;   0;   0;   0; 101;
 119;   0;   0;   0;   0;   0; 112;   0;   0; 100;
   0; 111;   0;   0;   0;   0; 113; 117; 120;   0;
   0; 118;   0;   0; 116;   0; 102; 106; 270;   0;
   0; 105; 114;   0;   0;   0; 104; 115; 109;   0;
   0; 110;  99;   0;   0; 103; 107; 108;   0;   0;
   0;   0; 101; 119; 278; 279;   0;   0;   0; 112;
   0;   0;   0;   0; 111;   0;  43;  49;   0; 113;
 117;  47;  48;  50; 118;   0;  42; 116;  33;  58;
   0;  32;  30;   0;   0;   0;   0;  44;  39;   0;
   0;   0;  26;   0;  40;  25; 100;   0;   0;  31;
   0;   0;   0;   0;   0; 120;   0;   0;   0;  34;
  29;   0;   0; 102; 106;   0;  38;  37; 105; 114;
   0;   0;   0; 104; 115; 109;  41;   0; 110;  99;
   0;  28; 103; 107; 108;   0;   0; 155;   0; 101;
 119;   0;   0;   0;   0;   0; 112;   0;   0; 100;
   0; 111;   0;   0;   0;   0; 113; 117; 120;   0;
   0; 118; 434;   0; 116;   0; 102; 106;   0;   0;
   0; 105; 114;   0;   0;   0; 104; 115; 109;   0;
   0; 110;  99;   0;   0; 103; 107; 108;   0;   0;
   0;   0; 101; 119;   0;   0;   0;   0;   0; 112;
   0;   0; 100;   0; 111;   0;   0;   0;   0; 113;
 117; 120;   0;   0; 118; 432;   0; 116;   0; 102;
 106;   0;   0;   0; 105; 114;   0;   0;   0; 104;
 115; 109;   0;   0; 110;  99;   0;   0; 103; 107;
 108;   0;   0;   0;   0; 101; 119;   0;   0;   0;
   0;   0; 112;   0;   0; 100;   0; 111;   0;   0;
   0;   0; 113; 117; 120;   0;   0; 118;   0; 429;
 116;   0; 102; 106;  43;  49;   0; 105; 114;  47;
  48;  50; 104; 115; 109;   0;   0; 110;  99;   0;
   0; 103; 107; 108;   0;  44;   0;   0; 101; 119;
   0;   0;   0;  65; 100; 112;  66;   0;   0;   0;
 111; 422;   0; 120;   0; 113; 117;   0;   0;   0;
 118; 102; 106; 116;  70;  69; 105; 114;   0;   0;
 253; 104; 115; 109;  71;   0; 110;  99;   0;   0;
 103; 107; 108;   0;   0;   0;   0; 101; 119;   0;
   0;   0;   0;   0; 112;   0;   0; 100;   0; 111;
   0;   0;   0;   0; 113; 117; 120;   0;   0; 118;
   0; 420; 116;   0; 102; 106;  43;  49;   0; 105;
 114;  47;  48;  50; 104; 115; 109;   0;   0; 110;
  99;   0;   0; 103; 107; 108;   0;  44;   0;   0;
 101; 119;   0;   0;   0;  65; 100; 112;  66;   0;
   0;   0; 111; 384;   0; 120;   0; 113; 117;   0;
   0;   0; 118; 102; 106; 116;  70;  69; 105; 114;
   0;   0; 189; 104; 115; 109;  71;   0; 110;  99;
   0;   0; 103; 107; 108;   0;   0;   0;   0; 101;
 119;   0;   0;   0;   0; 100; 112;   0;   0;   0;
   0; 111; 383;   0; 120;   0; 113; 117;   0;   0;
   0; 118; 102; 106; 116;   0;   0; 105; 114;   0;
   0;   0; 104; 115; 109;   0;   0; 110;  99;   0;
   0; 103; 107; 108;   0;   0;   0;   0; 101; 119;
   0;   0;   0;   0;   0; 112;   0;   0; 100;   0;
 111;   0;   0;   0;   0; 113; 117; 120;   0;   0;
 118; 380;   0; 116;   0; 102; 106;  43;  49;   0;
 105; 114;  47;  48;  50; 104; 115; 109;   0;   0;
 110;  99;   0;   0; 103; 107; 108;   0;  44;   0;
   0; 101; 119;   0; 378;   0;  65; 100; 112;  66;
   0;   0;   0; 111;   0;   0; 120;   0; 113; 117;
   0;   0;   0; 118; 102; 106; 116;  70;  69; 105;
 114;   0;   0; 122; 104; 115; 109;  71;   0; 110;
  99;   0;   0; 103; 107; 108;   0;   0;   0;   0;
 101; 119;   0; 340;   0;   0; 100; 112;   0;   0;
   0;   0; 111;   0;   0; 120;   0; 113; 117;   0;
   0;   0; 118; 102; 106; 116;   0;   0; 105; 114;
   0;   0;   0; 104; 115; 109;   0;   0; 110;  99;
   0;   0; 103; 107; 108; 283;   0;   0;   0; 101;
 119;   0;   0;   0;   0; 100; 112;   0;   0;   0;
   0; 111;   0;   0; 120;   0; 113; 117;   0;   0;
   0; 118; 102; 106; 116;   0;   0; 105; 114;   0;
   0;   0; 104; 115; 109;   0;   0; 110;  99;   0;
   0; 103; 107; 108;   0;   0;   0;   0; 101; 119;
   0;   0;   0;   0;   0; 112;   0;   0; 100;   0;
 111;   0;   0;   0;   0; 113; 117; 120;   0;   0;
 118;   0; 271; 116;   0; 102; 106;  43;  49;   0;
 105; 114;  47;  48;  50; 104; 115; 109;   0;   0;
 110;  99;   0;   0; 103; 107; 108;   0;  44;   0;
   0; 101; 119;   0;   0;   0;  65; 100; 112;  66;
   0;   0;   0; 111;   0;   0; 120;  98; 113; 117;
   0;   0;   0; 118; 102; 106; 116;  70; 195; 105;
 114;   0;   0;   0; 104; 115; 109;  71;   0; 110;
  99;   0;   0; 103; 107; 108;   0;   0;   0;   0;
 101; 119;   0;   0;   0;   0; 100; 112;   0;   0;
   0;   0; 111;   0;   0; 120;   0; 113; 117;   0;
   0;   0; 118; 102; 106; 116;   0;   0; 105; 114;
   0;   0;   0; 104; 115; 109;   0;   0; 110;  99;
   0;   0; 103; 107; 108;   0;   0;   0;   0; 101;
   0;   0;   0;   0;   0; 100; 112;   0;   0; 379;
   0; 111;   0;   0; 120;   0; 113; 117;   0;   0;
   0; 118; 102; 106; 116;   0;   0; 105; 114;   0;
   0;   0; 104; 115; 109;   0;   0; 110;  99;   0;
   0; 103; 107; 108;   0;   0;   0;   0; 101;   0;
   0;   0;   0;   0; 163; 112;   0;   0;   0;   0;
 111;   0; 183;   0;   0; 113; 117;   0;   0;   0;
 118; 167; 174; 116;   0;   0; 173; 170; 182;   0;
   0; 165; 178; 172;   0;   0; 181;   0;   0;   0;
 164; 177; 171;   0;   0;  43;  49; 166;   0;   0;
  47;  48;  50;   0; 169;  42;   0;  33;  58; 180;
  32;  30;   0;   0; 168; 175;  44;  39;   0; 176;
   0;  26; 179;  40;  25;   0;   0;   0;  31;   0;
   0;   0;   0;   0;   0;   0;   0; 152;  34;  29;
   0;   0;   0;   0;   0;  38;  37;   0;   0;   0;
   0;  43;  49;   0;   0;  41;  47;  48;  50;   0;
  28;  42;   0;  33;  58;   0;  32;  30;   0;   0;
   0;   0;  44;  39;   0;   0;   0;  26;   0;  40;
  25;   0;   0;   0;  31;   0;   0;   0;   0;   0;
   0;   0;   0;   0;  34;  29;   0;   0;   0; 149;
   0;  38;  37;   0;   0;   0;   0;  43;  49;   0;
   0;  41;  47;  48;  50;   0;  28;  42;   0;  33;
  58;   0;  32;  30;   0;   0;   0;   0;  44;  39;
   0;   0;   0;  26;   0;  40;  25; 100;   0;   0;
  31;   0;   0;   0;   0;   0; 120;   0;   0;   0;
  34;  29;   0;   0; 102; 106;   0;  38;  37; 105;
 114;   0;   0;   0; 104; 115; 109;  41;   0; 110;
   0;   0;  28; 103; 107; 108;   0; 100;   0;   0;
 101;   0;   0;   0;   0;   0; 120; 112;   0;   0;
   0;   0; 111;   0; 102; 106;   0; 113; 117; 105;
 114;   0; 118;   0; 104; 115; 109; 100;   0; 110;
   0;   0;   0; 103; 107; 108; 120;   0;   0;   0;
 101;   0;   0;   0; 102; 106;   0; 112;   0; 105;
 114;   0; 111;   0; 104; 115; 109; 113; 117; 110;
   0;   0;   0; 103; 107; 108;   0;  43;  49;   0;
 101;   0;  47;  48;  50;   0;   0; 112;   0;  43;
  49;   0; 111;   0;  47;  48;  50; 113;  44;  42;
   0;   0;   0;   0;   0;   0;  65;   0;   0;  66;
  44;  39;   0;   0;   0;   0;   0;  40;   0; 201;
   0;   0;   0;   0;   0;   0;   0;  70;  69;   0;
   0;   0;   0;   0;   0;   0;   0;  71;   0;  38;
  37;   0;   0;   0;   0;   0;   0;   0;   0;  41 |];;
let  yypact = [|

 520;-1000;-1000;-1000;  18;1870;  31;  31; 633;  19;
  57;  12;-119;-119;-119;  19;-234;  43;1519;1340;
-234;  43;  55;-1000; 295;1870;1870; -20;1870;1870;
  19;1870; 633; 633;1870;-1000;-1000;1814;1758; 879;
1870;  12;2022;-246;1715;-1000;-1000;-1000;-1000;-1000;
-1000;-1000;  19;-234;  43;  55;-1000;1568;1189;-1000;
-1000;-159;-1000;1540;-1000;  36;-1000;-1000;-1000; 179;
2010;  -8;-1000;-1000;-1000;-246;-1000;-1000; -63;  12;
-1000;-1000;-119;  53;  12;-1000; -63;-1000;-255;-158;
-1000;-259;  51;-226;-1000;-1000;-260; -91;-1000;1870;
1870;1870;1870;1870;1870;1870;1870;1870;1870;1870;
1870;1870;1870;1870;1870;1870;1870;1870;1870;1870;
1087;-212; 633;-254;-151; 633;-263;-267;-271;  38;
-1000;  12;1870; -51;  14;1968;1870; 767;1466; -38;
 661;-1000;   6; 633;-1000;-1000;-1000;-164; 612;-1000;
 820;-146;-1000;1666;-280;-1000;1417;-167;-1000; -39;
 -96;  19;-1000;-1000;-1000;-1000;-1000;-1000;-1000;-1000;
-1000;-1000;-1000;-1000;-1000;-1000;-1000;-1000;-1000;-1000;
-1000;-1000;-1000;-1000;-278;-279;-281;-282;  21; 633;
  46; 633; 633; 633;-1000; 179;-1000;-1000;-1000;-1000;
-215;-1000;-133;-172;-192;-138;-1000; -41;-119;-119;
-1000;-160;-144;-1000;-1000;-255;-1000;  19;-119;-1000;
-259;-1000;-234;-228; -52;-1000;-260;-1000;  43;-291;
-1000; 441;  14;  14;  14; -71; -71; 232; -35; -35;
 -35; -35; -35; -35; -35; -35; -35; -35;1666;1938;
1898;1568;-1000; 633;-1000;1870;-220; 633;1870; -46;
-1000;-1000;-1000;-1000; -21;1368;-1000;  12;1870;1666;
1870;1870;1870; 633;1870;-1000;1870; 633;-119;-1000;
1870;-1000;-1000;-1000;  12;-1000;1870;-1000;-1000;-1000;
-1000;-1000;  20;-1000; -16;-1000; -33; -56;-186;-223;
-119;-1000;-1000; 633;-1000;  -8; 633;-1000; -40; -63;
  12;-1000;-119;-1000;-1000; -76;-1000;-1000;-1000;-207;
-119;-190; -52;-1000;-226;-1000;-1000;-1000;-150;-119;
-1000;1870;-1000;1568;-1000;1870;-1000;1568;1870;1870;
 -29;-1000;1319;1617;1266; 710;-1000;1217;1168;-1000;
-180; -70;1666;-1000;1666; 633;-1000;-142;-1000;-1000;
-159;-119;-1000; -72;  22;-277;-291; -63;-1000;-1000;
-1000;-291;  12;-1000;1568;1568;1666;1870;-1000;1870;
-1000;1870;-308; 633; 633;1870;-1000;-1000;-1000;-1000;
-1000; -89;-1000;-119;-1000;  33;-1000;-277;-1000;  43;
-149;  23;-1000;1666;1666;1115;1870;-1000;-1000;1066;
-1000; -63;  30;-1000;-1000;-202;-149;-1000;-291;-179;
1870;1013; 633;-1000;-1000;-1000;-1000;-119; 960;1870;
-1000; -63;-1000; 907;-1000 |];;
let  yypgo = [|

   0; 466; 459; 452; 446;  67; 370; 490;  79;   0;
 391; 346;   4;  35; 444; 334; 322; 438;  29;  24;
 440; 439;   5;   3;   8; 434; 433;  17;   2; 427;
 419; 415; 414; 316; 412; 410; 331; 404; 396; 324;
 318; 315; 392; 381; 456; 319; 329; 320;  32; 327;
 221; 379;  28;   6;   7; 332; 378; 147; 142; 374;
 372;  26;  11; 371;  27; 369; 347; 337; 335;  21;
   1; 333 |];;
let  yyr1 = [|

   0;   1;   2;   2;   2;   2;   2;   2;   2;   2;
   2;   2;   2;   2;   2;   2;   2;  18;  20;  20;
  21;  21;  23;  25;  25;  26;  26;  22;  29;  29;
  30;  30;  31;  31;  32;  32;  34;  34;  35;  35;
  27;  37;  37;  38;  38;  39;  36;  42;  42;  43;
  43;  33;   3;   3;   3;   3;   3;   3;   3;   4;
   4;   4;   4;   4;  46;  46;  48;  48;  49;  49;
  50;  51;  51;   5;   5;   5;   5;   5;   5;   5;
   5;   5;   5;   5;   5;   5;   5;   5;   5;   5;
   5;   5;   5;   5;   5;   5;   5;   5;   5;   5;
   5;   5;   5;   5;   5;   5;   5;   5;   5;   5;
   5;   5;   5;   5;  47;  47;  47;  47;  47;  47;
  47;  47;  47;  47;  47;  47;  47;  47;   6;   7;
   7;   7;   7;  53;  53;  52;  52;  54;  54;  44;
  44;  56;  56;  57;  57;  58;  58;  58;  59;  60;
  60;  61;  61;  55;  55;   8;   8;   8;   8;   8;
   8;  62;  62;  62;  62;  62;  62;  62;  62;  62;
  62;  62;  62;   9;   9;  63;  63;  63;  63;  63;
  63;  63;  63;  63;  63;  63;  63;  63;  63;  63;
  63;  63;  63;  63;  63;  63;  10;  11;  11;  12;
  12;  12;  13;  13;  13;  13;  13;  64;  64;  19;
  65;  14;  15;  16;  17;  41;  41;  66;  66;  40;
  68;  68;  68;  68;  24;  24;  28;  69;  69;  71;
  70;  70;  67;  67;  67;  45 |];;
let  yyr2 = [|

   0;   1;   1;   2;   2;   2;   2;   2;   2;   2;
   2;   2;   2;   2;   2;   2;   2;   2;   0;   1;
   1;   2;   2;   0;   1;   1;   2;   2;   0;   1;
   1;   2;   0;   1;   1;   2;   0;   1;   1;   2;
   2;   0;   1;   1;   2;   2;   2;   0;   1;   1;
   2;   2;   2;   3;   4;   3;   3;   3;   1;   3;
   3;   3;   3;   1;   2;   1;   3;   1;   1;   3;
   3;   1;   3;   1;   2;   3;   2;   2;   3;   3;
   3;   3;   3;   3;   3;   3;   3;   3;   3;   3;
   3;   3;   3;   3;   3;   3;   3;   3;   5;   6;
   6;   4;   5;   9;  10;   3;   4;   4;   5;   2;
   2;   4;   3;   4;   1;   1;   2;   3;   2;   3;
   2;   5;   3;   3;   3;   2;   3;   4;   1;   1;
   1;   1;   1;   5;   3;   5;   3;   5;   3;   3;
   1;   3;   4;   3;   1;   3;   1;   1;   3;   3;
   1;   3;   1;   2;   1;   1;   3;   3;   3;   2;
   3;   1;   2;   2;   1;   1;   1;   2;   2;   3;
   5;   3;   3;   1;   2;   1;   1;   1;   1;   1;
   1;   1;   1;   1;   1;   1;   1;   1;   1;   1;
   1;   1;   1;   1;   1;   1;   3;   1;   1;   1;
   3;   3;   1;   1;   2;   4;   3;   1;   3;   2;
   4;   1;   2;   2;   2;   3;   5;   2;   3;   3;
   0;   3;   5;   2;   3;   1;   4;   1;   3;   2;
   1;   0;   4;   1;   0;   2 |];;
let  yychk = [|

-1000;  -1;  -2;  -3; 336; 337; 338; 339; 340; 341;
 342; 343; 344; 345; 346; 347; 348; 349;  -5; 270;
 323; 333; 332;   0; -47; 286; 283;  -9; 322; 301;
 273; 290; 272; 269; 300;  -6; -11; 308; 307; 279;
 285; 317; 267; 257; 278;  -7; -10; 262; 263; 258;
 264;  -4; 274; 323; 333; 332;   0;  -5; 270;  -6;
  -7;  -8; -62; -11;  -7; 286; 289;  -9; -10; 308;
 307; 317;  -9; 257; -10; 257; -11;  -9; -12; -13;
 -19; -11; 308; 310; -13; -14; -12; -15; -41;  -9;
 -16; -40; -67; 308; -19; -17; -24; 257; 318; 292;
 259; 302; 276; 295; 286; 281; 277; 296; 297; 288;
 291; 314; 309; 319; 282; 287; 327; 320; 324; 303;
 268; -44; 313; -56;  -8;  -9; -16; -17; -45; 257;
 -46; 280; 294; -47;  -5;  -5; 284;  -5;  -5;  -9;
  -5; -53; -55; -62;  -9; -10; -52;  -8;  -5; 305;
  -5; -49; 299;  -5; -49; 328;  -5; -51; -50; -11;
 -47; 311; -63; 259; 295; 286; 302; 276; 319; 309;
 282; 297; 288; 281; 277; 320; 324; 296; 287; 327;
 314; 291; 283; 267; -15; -16; -17; -45; -44; 313;
 275; 281; 292; 315; -60; 308; -62; 262; 263; 305;
  -8; 299; -57;  -8; -58; -59; 289; -11; 302; 271;
 -11; -65; -12; 257; -34; -35; -36; 316; 304; -37;
 -38; -39; 316; 257; -19; -31; -32; -33; 316; 293;
 -48;  -5;  -5;  -5;  -5;  -5;  -5;  -5;  -5;  -5;
  -5;  -5;  -5;  -5;  -5;  -5;  -5;  -5;  -5;  -5;
  -5;  -5; -44; 313; 318; 266; -44; 316; 291; -55;
 318; 318; 318; 258; -11;  -5; -46; 280; 294;  -5;
 331; 326; 291; 334; 271; -55; 271; 334; 304; 305;
 303; 299; 328; 298; 303; 306; 291;  -9; 318; 318;
 318; 318; -44; 257;  -8; -61;  -8;  -8; -61;  -8;
 304; 305; 299; 303; 306; 303; 291; -64; -13; -12;
 305; 305; 292; -36; -41; -12; -39; -40; -68; 291;
 314; -42; -43; -18; 292; -33; -24; -69; -71; -70;
 321; 292; -44;  -5; 318; 266; -44;  -5; 291; 284;
 305; -11;  -5;  -5;  -5;  -5; -52;  -5;  -5; -54;
  -8; -12;  -5; -50;  -5; 292; 305; -12; -57; -58;
  -8; 302; -11; -12; 291; -24; 317; -12; 305; -18;
 -19; 302; -13; -48;  -5;  -5;  -5; 284; 305; 312;
 325; 330; 329; 315; 315; 271; 305; -61; 305; -64;
 -25; -26; -27; 292; -66; 262; -29; -30; -23; 315;
 -28; -70; -69;  -5;  -5;  -5; 330; -53; -52;  -5;
 -27; -12; 258; -23; -24; -20; -21; -22; 303; 257;
 326;  -5; 315; 258; 306; -22; -28; 304;  -5; 326;
 -54; -12; 325;  -5; 325 |];;
let  yydef = [|

   0;  -2;   1;   2;   0;   0;   0;   0;   0;   0;
   0;   0;   0;   0;   0;   0; 234;   0;   0;   0;
 234;   0;   0;  58;  73;   0;   0; 198;   0;   0;
   0;   0;   0;   0;   0; 114; 115;   0;   0;   0;
   0;   0;   0; 173;   0; 128; 197; 129; 130; 131;
 132;   3;   0; 234;   0;   0;  63;   4;   0;   5;
   6;   7; 155;   0; 161;   0; 164;  -2;  -2;   0;
   0;   0;   8; 173;   9;   0;  10; 198;  11; 199;
 202; 203;   0;   0;  12;  13; 211;  14;  36;   0;
  15;  41;   0;   0; 233;  16;  32; 225;  52;   0;
   0;   0;   0;   0;   0;   0;   0;   0;   0;   0;
   0;   0;   0;   0;   0;   0;   0;   0;   0;   0;
   0;   0;   0; 140;   0; 165;   0;   0;   0;   0;
  74;   0;   0;  65;  76;  77;   0;   0;   0;   0;
   0; 109;   0; 154; 165; 166; 110;   0;   0; 116;
   0;   0; 118;  68;   0; 120;   0;   0;  71;   0;
 125;   0; 174; 175; 176; 177; 178; 179; 180; 181;
 182; 183; 184; 185; 186; 187; 188; 189; 190; 191;
 192; 193; 194; 195;   0;   0;   0;   0;   0;   0;
   0;   0;   0;   0; 159;   0; 150; 162; 163; 167;
   0; 168;   0; 144;   0; 146; 147;   0;   0;   0;
 204;   0;   0; 209; 212;  37;  38;   0;   0; 213;
  42;  43; 234; 220;  47; 214;  33;  34;   0; 231;
  75;  67;  79;  80;  81;  82;  83;  84;  85;  86;
  87;  88;  89;  90;  91;  92;  93;  94;  95;  96;
  97; 105; 112;   0;  53;   0;   0;   0;   0;   0;
  55;  56;  57; 235; 126;   0;  64;   0;   0;  78;
   0;   0;   0;   0;   0; 153;   0;   0;   0; 122;
   0; 117; 119; 123;   0; 124;   0; 196;  59;  60;
  61;  62;   0; 156; 157; 158; 152; 160;   0;   0;
   0; 172; 169;   0; 171;   0;   0; 200; 207; 201;
   0; 206;   0;  39;  46; 215;  44;  45; 219;   0;
   0;   0;  48;  49;   0;  35;  51; 224; 227;   0;
 230;   0; 113; 107;  54;   0; 139; 141;   0;   0;
 127; 126;   0; 101;   0;   0; 106; 134; 136; 111;
   0;   0;  69;  72;  70;   0; 149;   0; 143; 145;
 148;   0; 205;  23;   0;  28; 231; 223; 232;  50;
  17; 231; 229;  66; 108; 142;  98;   0; 127;   0;
 102;   0;   0;   0;   0;   0; 121; 151; 170; 208;
 210;  24;  25;   0; 216;   0; 221;  29;  30;   0;
  18;   0; 228;  99; 100;   0;   0; 133; 135; 138;
  26;  40; 217;  31;  22;   0;  19;  20; 231;   0;
   0;   0;   0; 218; 222;  21;  27;   0;   0;   0;
 137; 226; 103;   0; 104 |];;

(* END OF TABLES *)

let zinc_yytabs =
     (yyexca,yyact,yypact,yypgo,yyr1,yyr2,yychk,yydef);;

(* BEGINNING OF ACTIONS *)

let zinc_yyact_vect = vector (YYNPROD+1) of (fun () -> !yy_val);;
			
vect_assign(zinc_yyact_vect, 1, (fun () -> 
(* action line 107 "zinc.ly" *)
Repr (yy_exit_from_external (peek_val 0))));;
vect_assign(zinc_yyact_vect, 2, (fun () -> 
(* action line 108 "zinc.ly" *)
Repr (MLquote (dynamic ((peek_val 0):impl_phrase
)))));;
vect_assign(zinc_yyact_vect, 3, (fun () -> 
(* action line 110 "zinc.ly" *)
Repr (MLquote (dynamic ((peek_val 0):intf_phrase
)))));;
vect_assign(zinc_yyact_vect, 4, (fun () -> 
(* action line 112 "zinc.ly" *)
Repr (MLquote (dynamic ((peek_val 0):expression
)))));;
vect_assign(zinc_yyact_vect, 5, (fun () -> 
(* action line 114 "zinc.ly" *)
Repr (MLquote (dynamic ((peek_val 0):struct_constant
)))));;
vect_assign(zinc_yyact_vect, 6, (fun () -> 
(* action line 116 "zinc.ly" *)
Repr (MLquote (dynamic ((peek_val 0):atomic_constant
)))));;
vect_assign(zinc_yyact_vect, 7, (fun () -> 
(* action line 118 "zinc.ly" *)
Repr (MLquote (dynamic ((peek_val 0):pattern
)))));;
vect_assign(zinc_yyact_vect, 8, (fun () -> 
(* action line 120 "zinc.ly" *)
Repr (MLquote (dynamic ((peek_val 0):string
)))));;
vect_assign(zinc_yyact_vect, 9, (fun () -> 
(* action line 122 "zinc.ly" *)
Repr (MLquote (dynamic ((peek_val 0):qualified_ident
)))));;
vect_assign(zinc_yyact_vect, 10, (fun () -> 
(* action line 124 "zinc.ly" *)
Repr (MLquote (dynamic ((peek_val 0):global_reference
)))));;
vect_assign(zinc_yyact_vect, 11, (fun () -> 
(* action line 126 "zinc.ly" *)
Repr (MLquote (dynamic ((peek_val 0):type_expression
)))));;
vect_assign(zinc_yyact_vect, 12, (fun () -> 
(* action line 128 "zinc.ly" *)
Repr (MLquote (dynamic ((peek_val 0):type_expression
)))));;
vect_assign(zinc_yyact_vect, 13, (fun () -> 
(* action line 130 "zinc.ly" *)
Repr (MLquote (dynamic ((peek_val 0):typ
)))));;
vect_assign(zinc_yyact_vect, 14, (fun () -> 
(* action line 132 "zinc.ly" *)
Repr (MLquote (dynamic ((peek_val 0):(string * type_expression * prim_desc) list
)))));;
vect_assign(zinc_yyact_vect, 15, (fun () -> 
(* action line 134 "zinc.ly" *)
Repr (MLquote (dynamic ((peek_val 0):(string * string list * type_decl) list
)))));;
vect_assign(zinc_yyact_vect, 16, (fun () -> 
(* action line 136 "zinc.ly" *)
Repr (MLquote (dynamic ((peek_val 0):(string * (type_expression * mutable_flag) list) list
)))));;
vect_assign(zinc_yyact_vect, 17, (fun () -> 
(* action line 140 "zinc.ly" *)
Repr (
    let (tv:string) =     (peek_val 0)
     in     tv
)));;
vect_assign(zinc_yyact_vect, 18, (fun () -> 
(* action line 146 "zinc.ly" *)
Repr (
    []
)));;
vect_assign(zinc_yyact_vect, 19, (fun () -> 
(* action line 149 "zinc.ly" *)
Repr (
    rev (peek_val 0)
)));;
vect_assign(zinc_yyact_vect, 20, (fun () -> 
(* action line 154 "zinc.ly" *)
Repr (
    [(peek_val 0)]
)));;
vect_assign(zinc_yyact_vect, 21, (fun () -> 
(* action line 157 "zinc.ly" *)
Repr (
    (peek_val 0)::(peek_val 1)
)));;
vect_assign(zinc_yyact_vect, 22, (fun () -> 
(* action line 162 "zinc.ly" *)
Repr (
    let (cd:string * (type_expression * mutable_flag) list) =     (peek_val 0)
     in     cd
)));;
vect_assign(zinc_yyact_vect, 23, (fun () -> 
(* action line 168 "zinc.ly" *)
Repr (
    []
)));;
vect_assign(zinc_yyact_vect, 24, (fun () -> 
(* action line 171 "zinc.ly" *)
Repr (
    rev (peek_val 0)
)));;
vect_assign(zinc_yyact_vect, 25, (fun () -> 
(* action line 176 "zinc.ly" *)
Repr (
    [(peek_val 0)]
)));;
vect_assign(zinc_yyact_vect, 26, (fun () -> 
(* action line 179 "zinc.ly" *)
Repr (
    (peek_val 0)::(peek_val 1)
)));;
vect_assign(zinc_yyact_vect, 27, (fun () -> 
(* action line 184 "zinc.ly" *)
Repr (
    let (ld:string * type_expression * mutable_flag) =     (peek_val 0)
     in     ld
)));;
vect_assign(zinc_yyact_vect, 28, (fun () -> 
(* action line 190 "zinc.ly" *)
Repr (
    []
)));;
vect_assign(zinc_yyact_vect, 29, (fun () -> 
(* action line 193 "zinc.ly" *)
Repr (
    rev (peek_val 0)
)));;
vect_assign(zinc_yyact_vect, 30, (fun () -> 
(* action line 198 "zinc.ly" *)
Repr (
    [(peek_val 0)]
)));;
vect_assign(zinc_yyact_vect, 31, (fun () -> 
(* action line 201 "zinc.ly" *)
Repr (
    (peek_val 0)::(peek_val 1)
)));;
vect_assign(zinc_yyact_vect, 32, (fun () -> 
(* action line 206 "zinc.ly" *)
Repr (
    []
)));;
vect_assign(zinc_yyact_vect, 33, (fun () -> 
(* action line 209 "zinc.ly" *)
Repr (
    rev (peek_val 0)
)));;
vect_assign(zinc_yyact_vect, 34, (fun () -> 
(* action line 214 "zinc.ly" *)
Repr (
    [(peek_val 0)]
)));;
vect_assign(zinc_yyact_vect, 35, (fun () -> 
(* action line 217 "zinc.ly" *)
Repr (
    (peek_val 0)::(peek_val 1)
)));;
vect_assign(zinc_yyact_vect, 36, (fun () -> 
(* action line 222 "zinc.ly" *)
Repr (
    []
)));;
vect_assign(zinc_yyact_vect, 37, (fun () -> 
(* action line 225 "zinc.ly" *)
Repr (
    rev (peek_val 0)
)));;
vect_assign(zinc_yyact_vect, 38, (fun () -> 
(* action line 230 "zinc.ly" *)
Repr (
    [(peek_val 0)]
)));;
vect_assign(zinc_yyact_vect, 39, (fun () -> 
(* action line 233 "zinc.ly" *)
Repr (
    (peek_val 0)::(peek_val 1)
)));;
vect_assign(zinc_yyact_vect, 40, (fun () -> 
(* action line 238 "zinc.ly" *)
Repr (
    let (ty:type_expression) =     (peek_val 0)
     in     ty
)));;
vect_assign(zinc_yyact_vect, 41, (fun () -> 
(* action line 244 "zinc.ly" *)
Repr (
    []
)));;
vect_assign(zinc_yyact_vect, 42, (fun () -> 
(* action line 247 "zinc.ly" *)
Repr (
    rev (peek_val 0)
)));;
vect_assign(zinc_yyact_vect, 43, (fun () -> 
(* action line 252 "zinc.ly" *)
Repr (
    [(peek_val 0)]
)));;
vect_assign(zinc_yyact_vect, 44, (fun () -> 
(* action line 255 "zinc.ly" *)
Repr (
    (peek_val 0)::(peek_val 1)
)));;
vect_assign(zinc_yyact_vect, 45, (fun () -> 
(* action line 260 "zinc.ly" *)
Repr (
    let (td:string * string list * type_decl) =     (peek_val 0)
     in     td
)));;
vect_assign(zinc_yyact_vect, 46, (fun () -> 
(* action line 266 "zinc.ly" *)
Repr (
    let (vd:string * type_expression * prim_desc) =     (peek_val 0)
     in     vd
)));;
vect_assign(zinc_yyact_vect, 47, (fun () -> 
(* action line 272 "zinc.ly" *)
Repr (
    []
)));;
vect_assign(zinc_yyact_vect, 48, (fun () -> 
(* action line 275 "zinc.ly" *)
Repr (
    rev (peek_val 0)
)));;
vect_assign(zinc_yyact_vect, 49, (fun () -> 
(* action line 280 "zinc.ly" *)
Repr (
    [(peek_val 0)]
)));;
vect_assign(zinc_yyact_vect, 50, (fun () -> 
(* action line 283 "zinc.ly" *)
Repr (
    (peek_val 0)::(peek_val 1)
)));;
vect_assign(zinc_yyact_vect, 51, (fun () -> 
(* action line 288 "zinc.ly" *)
Repr (
    let (exc:string * (type_expression * mutable_flag) list) =     (peek_val 0)
     in     exc
)));;
vect_assign(zinc_yyact_vect, 52, (fun () -> 
(* action line 294 "zinc.ly" *)
Repr (
    let (e:expression) =     (peek_val 1)
     in     make_impl (Zexpr e)
)));;
vect_assign(zinc_yyact_vect, 53, (fun () -> 
(* action line 298 "zinc.ly" *)
Repr (
    let (L:(pattern * expression * int ref) list) =     (peek_val 1)
     in     make_impl (Zletdef (false,L))
)));;
vect_assign(zinc_yyact_vect, 54, (fun () -> 
(* action line 302 "zinc.ly" *)
Repr (
    let (L:(pattern * expression * int ref) list) =     (peek_val 1)
     in     make_impl (Zletdef (true,L))
)));;
vect_assign(zinc_yyact_vect, 55, (fun () -> 
(* action line 306 "zinc.ly" *)
Repr (
    let (tydecl:(string * string list * type_decl) list) =     (peek_val 1)
     in     make_impl (Ztypedef tydecl)
)));;
vect_assign(zinc_yyact_vect, 56, (fun () -> 
(* action line 310 "zinc.ly" *)
Repr (
    let (excdecl:(string * (type_expression * mutable_flag) list) list) =     (peek_val 1)
     in     make_impl (Zexcdef excdecl)
)));;
vect_assign(zinc_yyact_vect, 57, (fun () -> 
(* action line 314 "zinc.ly" *)
Repr (
    let (d:directiveu) =     (peek_val 1)
     in     make_impl (Zimpldirective d)
)));;
vect_assign(zinc_yyact_vect, 58, (fun () -> 
(* action line 318 "zinc.ly" *)
Repr (
    raise io_failure "eof"
)));;
vect_assign(zinc_yyact_vect, 59, (fun () -> 
(* action line 323 "zinc.ly" *)
Repr (
    let (valdecl:(string * type_expression * prim_desc) list) =     (peek_val 1)
     in     make_intf (Zvaluedecl valdecl)
)));;
vect_assign(zinc_yyact_vect, 60, (fun () -> 
(* action line 327 "zinc.ly" *)
Repr (
    let (tydecl:(string * string list * type_decl) list) =     (peek_val 1)
     in     make_intf (Ztypedecl tydecl)
)));;
vect_assign(zinc_yyact_vect, 61, (fun () -> 
(* action line 331 "zinc.ly" *)
Repr (
    let (excdecl:(string * (type_expression * mutable_flag) list) list) =     (peek_val 1)
     in     make_intf (Zexcdecl excdecl)
)));;
vect_assign(zinc_yyact_vect, 62, (fun () -> 
(* action line 335 "zinc.ly" *)
Repr (
    let (d:directiveu) =     (peek_val 1)
     in     make_intf (Zintfdirective d)
)));;
vect_assign(zinc_yyact_vect, 63, (fun () -> 
(* action line 339 "zinc.ly" *)
Repr (
    raise io_failure "eof"
)));;
vect_assign(zinc_yyact_vect, 64, (fun () -> 
(* action line 344 "zinc.ly" *)
Repr (
    let (el:expression list),(e:expression) =     (peek_val 0),(peek_val 1)
     in     e::el
)));;
vect_assign(zinc_yyact_vect, 65, (fun () -> 
(* action line 348 "zinc.ly" *)
Repr (
    let (e:expression) =     (peek_val 0)
     in     [e]
)));;
vect_assign(zinc_yyact_vect, 66, (fun () -> 
(* action line 354 "zinc.ly" *)
Repr (
    let (el:expression list),(e:expression) =     (peek_val 0),(peek_val 2)
     in     e::el
)));;
vect_assign(zinc_yyact_vect, 67, (fun () -> 
(* action line 358 "zinc.ly" *)
Repr (
    let (e:expression) =     (peek_val 0)
     in     [e]
)));;
vect_assign(zinc_yyact_vect, 68, (fun () -> 
(* action line 364 "zinc.ly" *)
Repr (
    let (e:expression) =     (peek_val 0)
     in     [e]
)));;
vect_assign(zinc_yyact_vect, 69, (fun () -> 
(* action line 368 "zinc.ly" *)
Repr (
    let (e:expression),(el:expression list) =     (peek_val 0),(peek_val 2)
     in     e::el
)));;
vect_assign(zinc_yyact_vect, 70, (fun () -> 
(* action line 374 "zinc.ly" *)
Repr (
    let (e:expression),(gr:global_reference) =     (peek_val 0),(peek_val 2)
     in     find_label gr,e
)));;
vect_assign(zinc_yyact_vect, 71, (fun () -> 
(* action line 380 "zinc.ly" *)
Repr (
    let (e:label_desc global * expression) =     (peek_val 0)
     in     [e]
)));;
vect_assign(zinc_yyact_vect, 72, (fun () -> 
(* action line 384 "zinc.ly" *)
Repr (
    let (e:label_desc global * expression),
(el:(label_desc global * expression) list) =     (peek_val 0),(peek_val 2)
     in     e::el
)));;
vect_assign(zinc_yyact_vect, 73, (fun () -> 
(* action line 391 "zinc.ly" *)
Repr (
    let (e:expression) =     (peek_val 0)
     in     e
)));;
vect_assign(zinc_yyact_vect, 74, (fun () -> 
(* action line 395 "zinc.ly" *)
Repr (
    let (el:expression list),(e:expression) =     (peek_val 0),(peek_val 1)
     in     make_apply (e,el)
)));;
vect_assign(zinc_yyact_vect, 75, (fun () -> 
(* action line 399 "zinc.ly" *)
Repr (
    let (el:expression list),(e:expression) =     (peek_val 0),(peek_val 2)
     in     make_tuple_expr (e::el)
)));;
vect_assign(zinc_yyact_vect, 76, (fun () -> 
(* action line 403 "zinc.ly" *)
Repr (
    let (e1:expression) =     (peek_val 0)
     in     make_unary_minus e1
)));;
vect_assign(zinc_yyact_vect, 77, (fun () -> 
(* action line 407 "zinc.ly" *)
Repr (
    let (e:expression) =     (peek_val 0)
     in     make_unop "not" e
)));;
vect_assign(zinc_yyact_vect, 78, (fun () -> 
(* action line 411 "zinc.ly" *)
Repr (
    let (e:expression),(id:string) =     (peek_val 0),(peek_val 2)
     in     make_expr (Zassign (id,e))
)));;
vect_assign(zinc_yyact_vect, 79, (fun () -> 
(* action line 415 "zinc.ly" *)
Repr (
    let (e2:expression),(i:string),(e1:expression) =     (peek_val 0),(peek_val 1),(peek_val 2)
     in     make_binop i e1 e2
)));;
vect_assign(zinc_yyact_vect, 80, (fun () -> 
(* action line 419 "zinc.ly" *)
Repr (
    let (e2:expression),(e1:expression) =     (peek_val 0),(peek_val 2)
     in     make_binop "*" e1 e2
)));;
vect_assign(zinc_yyact_vect, 81, (fun () -> 
(* action line 423 "zinc.ly" *)
Repr (
    let (e2:expression),(e1:expression) =     (peek_val 0),(peek_val 2)
     in     make_binop "/" e1 e2
)));;
vect_assign(zinc_yyact_vect, 82, (fun () -> 
(* action line 427 "zinc.ly" *)
Repr (
    let (e2:expression),(e1:expression) =     (peek_val 0),(peek_val 2)
     in     make_binop "+" e1 e2
)));;
vect_assign(zinc_yyact_vect, 83, (fun () -> 
(* action line 431 "zinc.ly" *)
Repr (
    let (e2:expression),(e1:expression) =     (peek_val 0),(peek_val 2)
     in     make_binop "-" e1 e2
)));;
vect_assign(zinc_yyact_vect, 84, (fun () -> 
(* action line 435 "zinc.ly" *)
Repr (
    let (e2:expression),(e1:expression) =     (peek_val 0),(peek_val 2)
     in     make_expr (Zconstruct (constr_cons,[e1; e2]))
)));;
vect_assign(zinc_yyact_vect, 85, (fun () -> 
(* action line 439 "zinc.ly" *)
Repr (
    let (e2:expression),(e1:expression) =     (peek_val 0),(peek_val 2)
     in     make_binop "@" e1 e2
)));;
vect_assign(zinc_yyact_vect, 86, (fun () -> 
(* action line 443 "zinc.ly" *)
Repr (
    let (e2:expression),(e1:expression) =     (peek_val 0),(peek_val 2)
     in     make_binop "^" e1 e2
)));;
vect_assign(zinc_yyact_vect, 87, (fun () -> 
(* action line 447 "zinc.ly" *)
Repr (
    let (e2:expression),(e1:expression) =     (peek_val 0),(peek_val 2)
     in     make_binop "<" e1 e2
)));;
vect_assign(zinc_yyact_vect, 88, (fun () -> 
(* action line 451 "zinc.ly" *)
Repr (
    let (e2:expression),(e1:expression) =     (peek_val 0),(peek_val 2)
     in     make_binop ">" e1 e2
)));;
vect_assign(zinc_yyact_vect, 89, (fun () -> 
(* action line 455 "zinc.ly" *)
Repr (
    let (e2:expression),(e1:expression) =     (peek_val 0),(peek_val 2)
     in     make_binop "=" e1 e2
)));;
vect_assign(zinc_yyact_vect, 90, (fun () -> 
(* action line 459 "zinc.ly" *)
Repr (
    let (e2:expression),(e1:expression) =     (peek_val 0),(peek_val 2)
     in     make_binop "==" e1 e2
)));;
vect_assign(zinc_yyact_vect, 91, (fun () -> 
(* action line 463 "zinc.ly" *)
Repr (
    let (e2:expression),(e1:expression) =     (peek_val 0),(peek_val 2)
     in     make_binop ">=" e1 e2
)));;
vect_assign(zinc_yyact_vect, 92, (fun () -> 
(* action line 467 "zinc.ly" *)
Repr (
    let (e2:expression),(e1:expression) =     (peek_val 0),(peek_val 2)
     in     make_binop "<=" e1 e2
)));;
vect_assign(zinc_yyact_vect, 93, (fun () -> 
(* action line 471 "zinc.ly" *)
Repr (
    let (e2:expression),(e1:expression) =     (peek_val 0),(peek_val 2)
     in     make_binop "<>" e1 e2
)));;
vect_assign(zinc_yyact_vect, 94, (fun () -> 
(* action line 475 "zinc.ly" *)
Repr (
    let (e2:expression),(e1:expression) =     (peek_val 0),(peek_val 2)
     in     make_binop "!=" e1 e2
)));;
vect_assign(zinc_yyact_vect, 95, (fun () -> 
(* action line 479 "zinc.ly" *)
Repr (
    let (e2:expression),(e1:expression) =     (peek_val 0),(peek_val 2)
     in     make_binop ":=" e1 e2
)));;
vect_assign(zinc_yyact_vect, 96, (fun () -> 
(* action line 483 "zinc.ly" *)
Repr (
    let (e2:expression),(e1:expression) =     (peek_val 0),(peek_val 2)
     in     make_expr (Zsequand (e1,e2))
)));;
vect_assign(zinc_yyact_vect, 97, (fun () -> 
(* action line 487 "zinc.ly" *)
Repr (
    let (e2:expression),(e1:expression) =     (peek_val 0),(peek_val 2)
     in     make_expr (Zsequor (e1,e2))
)));;
vect_assign(zinc_yyact_vect, 98, (fun () -> 
(* action line 491 "zinc.ly" *)
Repr (
    let (e2:expression),(gr:global_reference),(e1:expression) =     (peek_val 0),(peek_val 2),(peek_val 4)
     in     make_expr (Zrecord_update (e1,find_label gr,e2))
)));;
vect_assign(zinc_yyact_vect, 99, (fun () -> 
(* action line 495 "zinc.ly" *)
Repr (
    let (e3:expression),(e2:expression),(e1:expression) =     (peek_val 0),(peek_val 3),(peek_val 5)
     in     make_ternop "vect_assign" e1 e2 e3
)));;
vect_assign(zinc_yyact_vect, 100, (fun () -> 
(* action line 499 "zinc.ly" *)
Repr (
    let (e3:expression),(e2:expression),(e1:expression) =     (peek_val 0),(peek_val 2),(peek_val 4)
     in     make_expr (Zcondition (e1,e2,e3))
)));;
vect_assign(zinc_yyact_vect, 101, (fun () -> 
(* action line 503 "zinc.ly" *)
Repr (
    let (e2:expression),(e1:expression) =     (peek_val 0),(peek_val 2)
     in     make_expr (Zcondition (e1,e2,make_expr (Zconstruct (constr_void,[]))))
)));;
vect_assign(zinc_yyact_vect, 102, (fun () -> 
(* action line 507 "zinc.ly" *)
Repr (
    let (e2:expression),(e1:expression) =     (peek_val 1),(peek_val 3)
     in     make_expr (Zwhile (e1,e2))
)));;
vect_assign(zinc_yyact_vect, 103, (fun () -> 
(* action line 511 "zinc.ly" *)
Repr (
    let (e3:expression),(e2:expression),(e1:expression),(id:string) =     (peek_val 1),(peek_val 3),(peek_val 5),(peek_val 7)
     in     make_expr (Zfor (id,e1,e2,true,e3))
)));;
vect_assign(zinc_yyact_vect, 104, (fun () -> 
(* action line 515 "zinc.ly" *)
Repr (
    let (e3:expression),(e2:expression),(e1:expression),(id:string) =     (peek_val 1),(peek_val 3),(peek_val 6),(peek_val 8)
     in     make_expr (Zfor (id,e1,e2,false,e3))
)));;
vect_assign(zinc_yyact_vect, 105, (fun () -> 
(* action line 519 "zinc.ly" *)
Repr (
    let (e2:expression),(e1:expression) =     (peek_val 0),(peek_val 2)
     in     make_expr (Zsequence (e1,e2))
)));;
vect_assign(zinc_yyact_vect, 106, (fun () -> 
(* action line 523 "zinc.ly" *)
Repr (
    let (M:(pattern list * expression) list),(e:expression) =     (peek_val 0),(peek_val 2)
     in     make_expr (Zapply (make_expr (Zfunction M),[e]))
)));;
vect_assign(zinc_yyact_vect, 107, (fun () -> 
(* action line 527 "zinc.ly" *)
Repr (
    let (e:expression),(L:(pattern * expression * int ref) list) =     (peek_val 0),(peek_val 2)
     in     make_expr (Zlet (false,L,e))
)));;
vect_assign(zinc_yyact_vect, 108, (fun () -> 
(* action line 531 "zinc.ly" *)
Repr (
    let (e:expression),(L:(pattern * expression * int ref) list) =     (peek_val 0),(peek_val 2)
     in     make_expr (Zlet (true,L,e))
)));;
vect_assign(zinc_yyact_vect, 109, (fun () -> 
(* action line 535 "zinc.ly" *)
Repr (
    let (M:(pattern list * expression) list) =     (peek_val 0)
     in     make_expr (Zfunction M)
)));;
vect_assign(zinc_yyact_vect, 110, (fun () -> 
(* action line 539 "zinc.ly" *)
Repr (
    let (M:(pattern list * expression) list) =     (peek_val 0)
     in     make_expr (Zfunction M)
)));;
vect_assign(zinc_yyact_vect, 111, (fun () -> 
(* action line 543 "zinc.ly" *)
Repr (
    let (M:(pattern * expression) list),(e:expression) =     (peek_val 0),(peek_val 2)
     in     make_expr (Ztrywith (e,M))
)));;
vect_assign(zinc_yyact_vect, 112, (fun () -> 
(* action line 547 "zinc.ly" *)
Repr (
    let (L:(pattern * expression * int ref) list),(e:expression) =     (peek_val 0),(peek_val 2)
     in     make_expr (Zlet (false,L,e))
)));;
vect_assign(zinc_yyact_vect, 113, (fun () -> 
(* action line 551 "zinc.ly" *)
Repr (
    let (L:(pattern * expression * int ref) list),(e:expression) =     (peek_val 0),(peek_val 3)
     in     make_expr (Zlet (true,L,e))
)));;
vect_assign(zinc_yyact_vect, 114, (fun () -> 
(* action line 557 "zinc.ly" *)
Repr (
    let (sc:struct_constant) =     (peek_val 0)
     in     make_expr (Zconstant sc)
)));;
vect_assign(zinc_yyact_vect, 115, (fun () -> 
(* action line 561 "zinc.ly" *)
Repr (
    let (gr:global_reference) =     (peek_val 0)
     in     expr_constr_or_ident gr
)));;
vect_assign(zinc_yyact_vect, 116, (fun () -> 
(* action line 565 "zinc.ly" *)
Repr (
    make_expr (Zconstruct (constr_void,[]))
)));;
vect_assign(zinc_yyact_vect, 117, (fun () -> 
(* action line 568 "zinc.ly" *)
Repr (
    let (el:expression list) =     (peek_val 1)
     in     make_list el
)));;
vect_assign(zinc_yyact_vect, 118, (fun () -> 
(* action line 572 "zinc.ly" *)
Repr (
    make_expr (Zconstruct (constr_nil,[]))
)));;
vect_assign(zinc_yyact_vect, 119, (fun () -> 
(* action line 575 "zinc.ly" *)
Repr (
    let (el:expression list) =     (peek_val 1)
     in     make_expr (Zvector (rev el))
)));;
vect_assign(zinc_yyact_vect, 120, (fun () -> 
(* action line 579 "zinc.ly" *)
Repr (
    make_expr (Zvector [])
)));;
vect_assign(zinc_yyact_vect, 121, (fun () -> 
(* action line 582 "zinc.ly" *)
Repr (
    let (ty:type_expression),(e:expression) =     (peek_val 1),(peek_val 3)
     in     make_expr (Zconstraint (e,ty))
)));;
vect_assign(zinc_yyact_vect, 122, (fun () -> 
(* action line 586 "zinc.ly" *)
Repr (
    let (e:expression) =     (peek_val 1)
     in     e
)));;
vect_assign(zinc_yyact_vect, 123, (fun () -> 
(* action line 590 "zinc.ly" *)
Repr (
    let (e:expression) =     (peek_val 1)
     in     e
)));;
vect_assign(zinc_yyact_vect, 124, (fun () -> 
(* action line 594 "zinc.ly" *)
Repr (
    let (el:(label_desc global * expression) list) =     (peek_val 1)
     in     make_expr (Zrecord el)
)));;
vect_assign(zinc_yyact_vect, 125, (fun () -> 
(* action line 598 "zinc.ly" *)
Repr (
    let (e1:expression) =     (peek_val 0)
     in     make_unop "!" e1
)));;
vect_assign(zinc_yyact_vect, 126, (fun () -> 
(* action line 602 "zinc.ly" *)
Repr (
    let (gr:global_reference),(e:expression) =     (peek_val 0),(peek_val 2)
     in     make_expr (Zrecord_access (e,find_label gr))
)));;
vect_assign(zinc_yyact_vect, 127, (fun () -> 
(* action line 606 "zinc.ly" *)
Repr (
    let (e2:expression),(e1:expression) =     (peek_val 1),(peek_val 3)
     in     make_binop "vect_item" e1 e2
)));;
vect_assign(zinc_yyact_vect, 128, (fun () -> 
(* action line 612 "zinc.ly" *)
Repr (
    let (ac:atomic_constant) =     (peek_val 0)
     in     SCatom ac
)));;
vect_assign(zinc_yyact_vect, 129, (fun () -> 
(* action line 618 "zinc.ly" *)
Repr (
    let (i:int) =     (peek_val 0)
     in     ACint i
)));;
vect_assign(zinc_yyact_vect, 130, (fun () -> 
(* action line 622 "zinc.ly" *)
Repr (
    let (f:float) =     (peek_val 0)
     in     ACfloat f
)));;
vect_assign(zinc_yyact_vect, 131, (fun () -> 
(* action line 626 "zinc.ly" *)
Repr (
    let (s:string) =     (peek_val 0)
     in     ACstring s
)));;
vect_assign(zinc_yyact_vect, 132, (fun () -> 
(* action line 630 "zinc.ly" *)
Repr (
    let (c:char) =     (peek_val 0)
     in     ACchar c
)));;
vect_assign(zinc_yyact_vect, 133, (fun () -> 
(* action line 636 "zinc.ly" *)
Repr (
    let (M:(pattern list * expression) list),(e:expression),(pl:pattern list) =     (peek_val 0),(peek_val 2),(peek_val 4)
     in     (pl,e)::M
)));;
vect_assign(zinc_yyact_vect, 134, (fun () -> 
(* action line 640 "zinc.ly" *)
Repr (
    let (e:expression),(pl:pattern list) =     (peek_val 0),(peek_val 2)
     in     [pl,e]
)));;
vect_assign(zinc_yyact_vect, 135, (fun () -> 
(* action line 646 "zinc.ly" *)
Repr (
    let (M:(pattern list * expression) list),(e:expression),(p:pattern) =     (peek_val 0),(peek_val 2),(peek_val 4)
     in     ([p],e)::M
)));;
vect_assign(zinc_yyact_vect, 136, (fun () -> 
(* action line 650 "zinc.ly" *)
Repr (
    let (e:expression),(p:pattern) =     (peek_val 0),(peek_val 2)
     in     [[p],e]
)));;
vect_assign(zinc_yyact_vect, 137, (fun () -> 
(* action line 656 "zinc.ly" *)
Repr (
    let (M:(pattern * expression) list),(e:expression),(p:pattern) =     (peek_val 0),(peek_val 2),(peek_val 4)
     in     (p,e)::M
)));;
vect_assign(zinc_yyact_vect, 138, (fun () -> 
(* action line 660 "zinc.ly" *)
Repr (
    let (e:expression),(p:pattern) =     (peek_val 0),(peek_val 2)
     in     [p,e]
)));;
vect_assign(zinc_yyact_vect, 139, (fun () -> 
(* action line 666 "zinc.ly" *)
Repr (
    let (bl:(pattern * expression * int ref) list),
(b:pattern * expression * int ref) =     (peek_val 0),(peek_val 2)
     in     b::bl
)));;
vect_assign(zinc_yyact_vect, 140, (fun () -> 
(* action line 671 "zinc.ly" *)
Repr (
    let (b:pattern * expression * int ref) =     (peek_val 0)
     in     [b]
)));;
vect_assign(zinc_yyact_vect, 141, (fun () -> 
(* action line 677 "zinc.ly" *)
Repr (
    let (e:expression),(p:pattern) =     (peek_val 0),(peek_val 2)
     in     p,e,ref 0
)));;
vect_assign(zinc_yyact_vect, 142, (fun () -> 
(* action line 681 "zinc.ly" *)
Repr (
    let (e:expression),(pl:pattern list),(s:string) =     (peek_val 0),(peek_val 2),(peek_val 3)
     in     make_pat (Zvarpat s),make_expr (Zfunction [pl,e]),ref 0
)));;
vect_assign(zinc_yyact_vect, 143, (fun () -> 
(* action line 687 "zinc.ly" *)
Repr (
    let (pl:pattern),(p:pattern) =     (peek_val 0),(peek_val 2)
     in     make_pat (Zconstructpat (constr_cons,[p; pl]))
)));;
vect_assign(zinc_yyact_vect, 144, (fun () -> 
(* action line 691 "zinc.ly" *)
Repr (
    let (p:pattern) =     (peek_val 0)
     in     make_pat
 (Zconstructpat
  (constr_cons,[p; make_pat (Zconstructpat (constr_nil,[]))]))
)));;
vect_assign(zinc_yyact_vect, 145, (fun () -> 
(* action line 699 "zinc.ly" *)
Repr (
    let (pll:(label_desc global * pattern) list),
(pl:label_desc global * pattern) =     (peek_val 0),(peek_val 2)
     in     pl::pll
)));;
vect_assign(zinc_yyact_vect, 146, (fun () -> 
(* action line 704 "zinc.ly" *)
Repr (
    let (pl:label_desc global * pattern) =     (peek_val 0)
     in     [pl]
)));;
vect_assign(zinc_yyact_vect, 147, (fun () -> 
(* action line 708 "zinc.ly" *)
Repr (
    []
)));;
vect_assign(zinc_yyact_vect, 148, (fun () -> 
(* action line 713 "zinc.ly" *)
Repr (
    let (p:pattern),(gr:global_reference) =     (peek_val 0),(peek_val 2)
     in     find_label gr,p
)));;
vect_assign(zinc_yyact_vect, 149, (fun () -> 
(* action line 719 "zinc.ly" *)
Repr (
    let (pl:pattern list) =     (peek_val 1)
     in     pl
)));;
vect_assign(zinc_yyact_vect, 150, (fun () -> 
(* action line 723 "zinc.ly" *)
Repr (
    let (p:pattern) =     (peek_val 0)
     in     [p]
)));;
vect_assign(zinc_yyact_vect, 151, (fun () -> 
(* action line 729 "zinc.ly" *)
Repr (
    let (pl:pattern list),(p:pattern) =     (peek_val 0),(peek_val 2)
     in     p::pl
)));;
vect_assign(zinc_yyact_vect, 152, (fun () -> 
(* action line 733 "zinc.ly" *)
Repr (
    let (p:pattern) =     (peek_val 0)
     in     [p]
)));;
vect_assign(zinc_yyact_vect, 153, (fun () -> 
(* action line 739 "zinc.ly" *)
Repr (
    let (pl:pattern list),(p:pattern) =     (peek_val 0),(peek_val 1)
     in     p::pl
)));;
vect_assign(zinc_yyact_vect, 154, (fun () -> 
(* action line 743 "zinc.ly" *)
Repr (
    let (p:pattern) =     (peek_val 0)
     in     [p]
)));;
vect_assign(zinc_yyact_vect, 155, (fun () -> 
(* action line 749 "zinc.ly" *)
Repr (
    let (p:pattern) =     (peek_val 0)
     in     p
)));;
vect_assign(zinc_yyact_vect, 156, (fun () -> 
(* action line 753 "zinc.ly" *)
Repr (
    let (s:string),(p:pattern) =     (peek_val 0),(peek_val 2)
     in     make_pat (Zaliaspat (p,s))
)));;
vect_assign(zinc_yyact_vect, 157, (fun () -> 
(* action line 757 "zinc.ly" *)
Repr (
    let (p2:pattern),(p1:pattern) =     (peek_val 0),(peek_val 2)
     in     make_pat (Zconstructpat (constr_cons,[p1; p2]))
)));;
vect_assign(zinc_yyact_vect, 158, (fun () -> 
(* action line 761 "zinc.ly" *)
Repr (
    let (pl:pattern list),(p1:pattern) =     (peek_val 0),(peek_val 2)
     in     make_tuple_pat (p1::pl)
)));;
vect_assign(zinc_yyact_vect, 159, (fun () -> 
(* action line 765 "zinc.ly" *)
Repr (
    let (pl:pattern list),(c:global_reference) =     (peek_val 0),(peek_val 1)
     in     make_pat (Zconstructpat (find_constructor c,pl))
)));;
vect_assign(zinc_yyact_vect, 160, (fun () -> 
(* action line 769 "zinc.ly" *)
Repr (
    let (p2:pattern),(p1:pattern) =     (peek_val 0),(peek_val 2)
     in     make_pat (Zorpat (p1,p2))
)));;
vect_assign(zinc_yyact_vect, 161, (fun () -> 
(* action line 775 "zinc.ly" *)
Repr (
    let (ac:atomic_constant) =     (peek_val 0)
     in     make_pat (Zconstantpat ac)
)));;
vect_assign(zinc_yyact_vect, 162, (fun () -> 
(* action line 779 "zinc.ly" *)
Repr (
    let (i:int) =     (peek_val 0)
     in     make_pat (Zconstantpat (ACint (minus_int i)))
)));;
vect_assign(zinc_yyact_vect, 163, (fun () -> 
(* action line 783 "zinc.ly" *)
Repr (
    let (f:float) =     (peek_val 0)
     in     make_pat (Zconstantpat (ACfloat (minus_float f)))
)));;
vect_assign(zinc_yyact_vect, 164, (fun () -> 
(* action line 787 "zinc.ly" *)
Repr (
    make_pat Zwildpat
)));;
vect_assign(zinc_yyact_vect, 165, (fun () -> 
(* action line 790 "zinc.ly" *)
Repr (
    let (s:string) =     (peek_val 0)
     in     pat_constr_or_var s
)));;
vect_assign(zinc_yyact_vect, 166, (fun () -> 
(* action line 794 "zinc.ly" *)
Repr (
    let (q:qualified_ident) =     (peek_val 0)
     in     make_pat (Zconstructpat (find_constructor (GRmodname q),[]))
)));;
vect_assign(zinc_yyact_vect, 167, (fun () -> 
(* action line 798 "zinc.ly" *)
Repr (
    make_pat (Zconstructpat (constr_void,[]))
)));;
vect_assign(zinc_yyact_vect, 168, (fun () -> 
(* action line 801 "zinc.ly" *)
Repr (
    make_pat (Zconstructpat (constr_nil,[]))
)));;
vect_assign(zinc_yyact_vect, 169, (fun () -> 
(* action line 804 "zinc.ly" *)
Repr (
    let (p:pattern) =     (peek_val 1)
     in     p
)));;
vect_assign(zinc_yyact_vect, 170, (fun () -> 
(* action line 808 "zinc.ly" *)
Repr (
    let (ty:type_expression),(p:pattern) =     (peek_val 1),(peek_val 3)
     in     make_pat (Zconstraintpat (p,ty))
)));;
vect_assign(zinc_yyact_vect, 171, (fun () -> 
(* action line 812 "zinc.ly" *)
Repr (
    let (pl:(label_desc global * pattern) list) =     (peek_val 1)
     in     make_pat (Zrecordpat pl)
)));;
vect_assign(zinc_yyact_vect, 172, (fun () -> 
(* action line 816 "zinc.ly" *)
Repr (
    let (p:pattern) =     (peek_val 1)
     in     p
)));;
vect_assign(zinc_yyact_vect, 173, (fun () -> 
(* action line 822 "zinc.ly" *)
Repr (
    let (s:string) =     (peek_val 0)
     in     s
)));;
vect_assign(zinc_yyact_vect, 174, (fun () -> 
(* action line 826 "zinc.ly" *)
Repr (
    let (s:string) =     (peek_val 0)
     in     s
)));;
vect_assign(zinc_yyact_vect, 175, (fun () -> 
(* action line 832 "zinc.ly" *)
Repr (
    let (i:string) =     (peek_val 0)
     in     i
)));;
vect_assign(zinc_yyact_vect, 176, (fun () -> 
(* action line 836 "zinc.ly" *)
Repr (
    "+"
)));;
vect_assign(zinc_yyact_vect, 177, (fun () -> 
(* action line 839 "zinc.ly" *)
Repr (
    "-"
)));;
vect_assign(zinc_yyact_vect, 178, (fun () -> 
(* action line 842 "zinc.ly" *)
Repr (
    "*"
)));;
vect_assign(zinc_yyact_vect, 179, (fun () -> 
(* action line 845 "zinc.ly" *)
Repr (
    "/"
)));;
vect_assign(zinc_yyact_vect, 180, (fun () -> 
(* action line 848 "zinc.ly" *)
Repr (
    "<="
)));;
vect_assign(zinc_yyact_vect, 181, (fun () -> 
(* action line 851 "zinc.ly" *)
Repr (
    ">="
)));;
vect_assign(zinc_yyact_vect, 182, (fun () -> 
(* action line 854 "zinc.ly" *)
Repr (
    "<>"
)));;
vect_assign(zinc_yyact_vect, 183, (fun () -> 
(* action line 857 "zinc.ly" *)
Repr (
    "<"
)));;
vect_assign(zinc_yyact_vect, 184, (fun () -> 
(* action line 860 "zinc.ly" *)
Repr (
    ">"
)));;
vect_assign(zinc_yyact_vect, 185, (fun () -> 
(* action line 863 "zinc.ly" *)
Repr (
    "::"
)));;
vect_assign(zinc_yyact_vect, 186, (fun () -> 
(* action line 866 "zinc.ly" *)
Repr (
    "@"
)));;
vect_assign(zinc_yyact_vect, 187, (fun () -> 
(* action line 869 "zinc.ly" *)
Repr (
    "&"
)));;
vect_assign(zinc_yyact_vect, 188, (fun () -> 
(* action line 872 "zinc.ly" *)
Repr (
    "or"
)));;
vect_assign(zinc_yyact_vect, 189, (fun () -> 
(* action line 875 "zinc.ly" *)
Repr (
    "^"
)));;
vect_assign(zinc_yyact_vect, 190, (fun () -> 
(* action line 878 "zinc.ly" *)
Repr (
    "!="
)));;
vect_assign(zinc_yyact_vect, 191, (fun () -> 
(* action line 881 "zinc.ly" *)
Repr (
    ":="
)));;
vect_assign(zinc_yyact_vect, 192, (fun () -> 
(* action line 884 "zinc.ly" *)
Repr (
    "=="
)));;
vect_assign(zinc_yyact_vect, 193, (fun () -> 
(* action line 887 "zinc.ly" *)
Repr (
    "="
)));;
vect_assign(zinc_yyact_vect, 194, (fun () -> 
(* action line 890 "zinc.ly" *)
Repr (
    "not"
)));;
vect_assign(zinc_yyact_vect, 195, (fun () -> 
(* action line 893 "zinc.ly" *)
Repr (
    "!"
)));;
vect_assign(zinc_yyact_vect, 196, (fun () -> 
(* action line 898 "zinc.ly" *)
Repr (
    let (s:string),(modname:string) =     (peek_val 0),(peek_val 2)
     in     {qual=modname; id=s}
)));;
vect_assign(zinc_yyact_vect, 197, (fun () -> 
(* action line 904 "zinc.ly" *)
Repr (
    let (q:qualified_ident) =     (peek_val 0)
     in     GRmodname q
)));;
vect_assign(zinc_yyact_vect, 198, (fun () -> 
(* action line 908 "zinc.ly" *)
Repr (
    let (s:string) =     (peek_val 0)
     in     GRname s
)));;
vect_assign(zinc_yyact_vect, 199, (fun () -> 
(* action line 914 "zinc.ly" *)
Repr (
    let (ty:type_expression) =     (peek_val 0)
     in     ty
)));;
vect_assign(zinc_yyact_vect, 200, (fun () -> 
(* action line 918 "zinc.ly" *)
Repr (
    let (tyl:type_expression list),(ty1:type_expression) =     (peek_val 0),(peek_val 2)
     in     make_typ (Ztypeconstr (gr_type_tuple,ty1::tyl))
)));;
vect_assign(zinc_yyact_vect, 201, (fun () -> 
(* action line 922 "zinc.ly" *)
Repr (
    let (ty2:type_expression),(ty1:type_expression) =     (peek_val 0),(peek_val 2)
     in     make_typ (Ztypearrow (ty1,ty2))
)));;
vect_assign(zinc_yyact_vect, 202, (fun () -> 
(* action line 928 "zinc.ly" *)
Repr (
    let (tv:string) =     (peek_val 0)
     in     make_typ (Ztypevar tv)
)));;
vect_assign(zinc_yyact_vect, 203, (fun () -> 
(* action line 932 "zinc.ly" *)
Repr (
    let (gr:global_reference) =     (peek_val 0)
     in     make_typ (Ztypeconstr (gr,[]))
)));;
vect_assign(zinc_yyact_vect, 204, (fun () -> 
(* action line 936 "zinc.ly" *)
Repr (
    let (gr:global_reference),(ty:type_expression) =     (peek_val 0),(peek_val 1)
     in     make_typ (Ztypeconstr (gr,[ty]))
)));;
vect_assign(zinc_yyact_vect, 205, (fun () -> 
(* action line 940 "zinc.ly" *)
Repr (
    let (gr:global_reference),(tyl:type_expression list) =     (peek_val 0),(peek_val 2)
     in     make_typ (Ztypeconstr (gr,tyl))
)));;
vect_assign(zinc_yyact_vect, 206, (fun () -> 
(* action line 944 "zinc.ly" *)
Repr (
    let (ty:type_expression) =     (peek_val 1)
     in     ty
)));;
vect_assign(zinc_yyact_vect, 207, (fun () -> 
(* action line 950 "zinc.ly" *)
Repr (
    let (ty:type_expression) =     (peek_val 0)
     in     [ty]
)));;
vect_assign(zinc_yyact_vect, 208, (fun () -> 
(* action line 954 "zinc.ly" *)
Repr (
    let (tyl:type_expression list),(ty1:type_expression) =     (peek_val 0),(peek_val 2)
     in     ty1::tyl
)));;
vect_assign(zinc_yyact_vect, 209, (fun () -> 
(* action line 960 "zinc.ly" *)
Repr (
    let (s:string) =     (peek_val 0)
     in     s
)));;
vect_assign(zinc_yyact_vect, 210, (fun () -> 
(* action line 966 "zinc.ly" *)
Repr (
    let (tyl:type_expression list),(ty2:type_expression),(ty1:type_expression) =     (peek_val 0),(peek_val 1),(peek_val 3)
     in     ty1::ty2::tyl
)));;
vect_assign(zinc_yyact_vect, 211, (fun () -> 
(* action line 972 "zinc.ly" *)
Repr (
    let (ty:type_expression) =     (peek_val 0)
     in     reset_type_expression_vars [];push_type_level ();
let t = type_of_type_expression false ty in
 pop_type_level ();generalize_type t;t
)));;
vect_assign(zinc_yyact_vect, 212, (fun () -> 
(* action line 980 "zinc.ly" *)
Repr (
    let (vdl:(string * type_expression * prim_desc) list),
(vd1:string * type_expression * prim_desc) =     (peek_val 0),(peek_val 1)
     in     vd1::vdl
)));;
vect_assign(zinc_yyact_vect, 213, (fun () -> 
(* action line 987 "zinc.ly" *)
Repr (
    let (tdl:(string * string list * type_decl) list),
(td1:string * string list * type_decl) =     (peek_val 0),(peek_val 1)
     in     td1::tdl
)));;
vect_assign(zinc_yyact_vect, 214, (fun () -> 
(* action line 994 "zinc.ly" *)
Repr (
    let (excl:(string * (type_expression * mutable_flag) list) list),
(exc1:string * (type_expression * mutable_flag) list) =     (peek_val 0),(peek_val 1)
     in     exc1::excl
)));;
vect_assign(zinc_yyact_vect, 215, (fun () -> 
(* action line 1001 "zinc.ly" *)
Repr (
    let (ty:type_expression),(s:string) =     (peek_val 0),(peek_val 2)
     in     s,ty,ValueNotPrim
)));;
vect_assign(zinc_yyact_vect, 216, (fun () -> 
(* action line 1005 "zinc.ly" *)
Repr (
    let (p:prim_desc),(ty:type_expression),(s:string) =     (peek_val 0),(peek_val 2),(peek_val 4)
     in     s,ty,p
)));;
vect_assign(zinc_yyact_vect, 217, (fun () -> 
(* action line 1011 "zinc.ly" *)
Repr (
    let (name:string),(arity:int) =     (peek_val 0),(peek_val 1)
     in     find_primitive arity name ""
)));;
vect_assign(zinc_yyact_vect, 218, (fun () -> 
(* action line 1015 "zinc.ly" *)
Repr (
    let (flags:string),(name:string),(arity:int) =     (peek_val 0),(peek_val 1),(peek_val 2)
     in     find_primitive arity name flags
)));;
vect_assign(zinc_yyact_vect, 219, (fun () -> 
(* action line 1021 "zinc.ly" *)
Repr (
    let (ty_def:type_decl),(ty_name:string),(params:string list) =     (peek_val 0),(peek_val 1),(peek_val 2)
     in     ty_name,params,ty_def
)));;
vect_assign(zinc_yyact_vect, 220, (fun () -> 
(* action line 1027 "zinc.ly" *)
Repr (
    Zabstract_type
)));;
vect_assign(zinc_yyact_vect, 221, (fun () -> 
(* action line 1030 "zinc.ly" *)
Repr (
    let (cdl:(string * (type_expression * mutable_flag) list) list),
(cd1:string * (type_expression * mutable_flag) list) =     (peek_val 0),(peek_val 1)
     in     Zvariant_type (cd1::cdl)
)));;
vect_assign(zinc_yyact_vect, 222, (fun () -> 
(* action line 1035 "zinc.ly" *)
Repr (
    let (ldl:(string * type_expression * mutable_flag) list),
(ld1:string * type_expression * mutable_flag) =     (peek_val 1),(peek_val 2)
     in     Zrecord_type (ld1::ldl)
)));;
vect_assign(zinc_yyact_vect, 223, (fun () -> 
(* action line 1040 "zinc.ly" *)
Repr (
    let (ty:type_expression) =     (peek_val 0)
     in     Zabbrev_type ty
)));;
vect_assign(zinc_yyact_vect, 224, (fun () -> 
(* action line 1046 "zinc.ly" *)
Repr (
    let (tyl:(type_expression * mutable_flag) list),(s:string) =     (peek_val 0),(peek_val 2)
     in     s,tyl
)));;
vect_assign(zinc_yyact_vect, 225, (fun () -> 
(* action line 1050 "zinc.ly" *)
Repr (
    let (s:string) =     (peek_val 0)
     in     s,[]
)));;
vect_assign(zinc_yyact_vect, 226, (fun () -> 
(* action line 1056 "zinc.ly" *)
Repr (
    let (ty:type_expression),(s:string),(m:mutable_flag) =     (peek_val 0),(peek_val 2),(peek_val 3)
     in     s,ty,m
)));;
vect_assign(zinc_yyact_vect, 227, (fun () -> 
(* action line 1062 "zinc.ly" *)
Repr (
    let (arg:type_expression * mutable_flag) =     (peek_val 0)
     in     [arg]
)));;
vect_assign(zinc_yyact_vect, 228, (fun () -> 
(* action line 1066 "zinc.ly" *)
Repr (
    let (arg_list:(type_expression * mutable_flag) list),
(arg:type_expression * mutable_flag) =     (peek_val 0),(peek_val 2)
     in     arg::arg_list
)));;
vect_assign(zinc_yyact_vect, 229, (fun () -> 
(* action line 1073 "zinc.ly" *)
Repr (
    let (ty:type_expression),(m:mutable_flag) =     (peek_val 0),(peek_val 1)
     in     ty,m
)));;
vect_assign(zinc_yyact_vect, 230, (fun () -> 
(* action line 1079 "zinc.ly" *)
Repr (
    Mutable
)));;
vect_assign(zinc_yyact_vect, 231, (fun () -> 
(* action line 1082 "zinc.ly" *)
Repr (
    Notmutable
)));;
vect_assign(zinc_yyact_vect, 232, (fun () -> 
(* action line 1087 "zinc.ly" *)
Repr (
    let (tvl:string list),(tv1:string) =     (peek_val 1),(peek_val 2)
     in     tv1::tvl
)));;
vect_assign(zinc_yyact_vect, 233, (fun () -> 
(* action line 1091 "zinc.ly" *)
Repr (
    let (tv:string) =     (peek_val 0)
     in     [tv]
)));;
vect_assign(zinc_yyact_vect, 234, (fun () -> 
(* action line 1095 "zinc.ly" *)
Repr (
    []
)));;
vect_assign(zinc_yyact_vect, 235, (fun () -> 
(* action line 1100 "zinc.ly" *)
Repr (
    let (arg:string),(id:string) =     (peek_val 0),(peek_val 1)
     in     Zdir (id,arg)
)));; 

let zinc_yyactions n = vect_item(zinc_yyact_vect, n) ();;

(* END OF ACTIONS *)

let zinc_lsyntax =
             (zinc_strings,zinc_double,
	     (zinc_NUM,zinc_INT,zinc_FLOAT,
              zinc_IDENT,zinc_BOOL,zinc_STRING,
              zinc_INFIX,zinc_CHAR,zinc_EOF),
	     (zinc_strdelim,zinc_cmndelim),
	     zinc_sub_syntaxes)
;;

let zinc_psyntax =
  (zinc_yyactions,zinc_yytabs,YYLAST);;

let zinc_syntax =
    CAML_system_make_Syntax
     ("zinc",zinc_syntax_flag,
        zinc_lsyntax,zinc_psyntax);;
	
(* syntax_flag = (yy_)lex; syntax_type = syntax/value *)

add_syntax (make_parser zinc_syntax_type  zinc_syntax);()
;;
(* Caml part *)
let zinc =
 mk_grammar "zinc" zinc_sub_syntaxes;;
directive declare_grammar "zinc" ("Implementation",["Interface";"Expr";"Struct_constant";"Atomic_constant";"Pattern";"Ide";"Qual_ident";"Ext_ident";"Type";"Simple_type";"Type_expr";"Value_decl";"Type_decl";"Exc_decl"]);;
default_ol_grammar:=("zinc","");;
